LeetCode 349|350 - Intersection of Two Arrays I/II


LeetCode 349 - Intersection of Two Arrays

Given two arrays, write a function to compute their intersection.
Example:
Given nums1 = [1, 2, 2, 1]nums2 = [2, 2], return [2].
Note:
  • Each element in the result must be unique.
  • The result can be in any order.
Use two hash sets
Time complexity: O(n)
    public int[] intersection(int[] nums1, int[] nums2) {
        Set<Integer> set = new HashSet<>();
        Set<Integer> intersect = new HashSet<>();
        for (int i = 0; i < nums1.length; i++) {
            set.add(nums1[i]);
        }
        for (int i = 0; i < nums2.length; i++) {
            if (set.contains(nums2[i])) {
                intersect.add(nums2[i]);
            }
        }
        int[] result = new int[intersect.size()];
        int i = 0;
        for (Integer num : intersect) {
            result[i++] = num;
        }
        return result;
    }
Sort both arrays, use two pointers
Time complexity: O(nlogn)
    public int[] intersection(int[] nums1, int[] nums2) {
        Set<Integer> set = new HashSet<>();
        Arrays.sort(nums1);
        Arrays.sort(nums2);
        int i = 0;
        int j = 0;
        while (i < nums1.length && j < nums2.length) {
            if (nums1[i] < nums2[j]) {
                i++;
            } else if (nums1[i] > nums2[j]) {
                j++;
            } else {
                set.add(nums1[i]);
                i++;
                j++;
            }
        }
        int[] result = new int[set.size()];
        int k = 0;
        for (Integer num : set) {
            result[k++] = num;
        }
        return result;
    }
Binary search
Time complexity: O(nlogn)
    public int[] intersection(int[] nums1, int[] nums2) {
        Set<Integer> set = new HashSet<>();
        Arrays.sort(nums2);
        for (Integer num : nums1) {
            if (binarySearch(nums2, num)) {
                set.add(num);
            }
        }
        int i = 0;
        int[] result = new int[set.size()];
        for (Integer num : set) {
            result[i++] = num;
        }
        return result;
    }
    
    public boolean binarySearch(int[] nums, int target) {
        int low = 0;
        int high = nums.length - 1;
        while (low <= high) {
            int mid = low + (high - low) / 2;
            if (nums[mid] == target) {
                return true;
            }
            if (nums[mid] > target) {
                high = mid - 1;
            } else {
                low = mid + 1;
            }
        }
        return false;
    }
Two-line java 8 solution using Stream
Set<Integer> set = Arrays.stream(nums2).boxed().collect(Collectors.toSet());
return Arrays.stream(nums1).distinct().filter(e-> set.contains(e)).toArray();
https://leetcode.com/problems/intersection-of-two-arrays-ii/
Given two arrays, write a function to compute their intersection.
Example:
Given nums1 = [1, 2, 2, 1]nums2 = [2, 2], return [2, 2].
Note:
  • Each element in the result should appear as many times as it shows in both arrays.
  • The result can be in any order.
Follow up:
  • What if the given array is already sorted? How would you optimize your algorithm?
  • What if nums1's size is small compared to num2's size? Which algorithm is better?
  • What if elements of nums2 are stored on disk, and the memory is limited such that you cannot load all elements into the memory at once?
https://discuss.leetcode.com/topic/45992/solution-to-3rd-follow-up-question
What if elements of nums2 are stored on disk, and the memory is
limited such that you cannot load all elements into the memory at
once?
  • If only nums2 cannot fit in memory, put all elements of nums1 into a HashMap, read chunks of array that fit into the memory, and record the intersections.
  • If both nums1 and nums2 are so huge that neither fit into the memory, sort them individually (external sort), then read 2 elements from each array at a time in memory, record intersections.
http://bookshadow.com/weblog/2016/05/21/leetcode-intersection-of-two-arrays-ii/


  • 如果数组已经排好序,怎样优化你的算法?
  • 如果nums1的长度<nums2的长度?哪一种算法更好?
  • 如果nums2的元素存储在磁盘上,并且内存大小有限,不足以将其一次性的加载到内存中。此时应当怎样做?
  • X. 解法I 排序(Sort)+双指针(Two Pointers)
    http://vegetablefinn.github.io/2016/05/21/350-Intersection-of-Two-Arrays-II/
    If the arrays are sorted, then we can use two points.
        public int[] intersect(int[] nums1, int[] nums2) {
            //先排序
            Arrays.sort(nums1);
            Arrays.sort(nums2);
            //确定head
            int nums1Head = 0;
            int nums2Head = 0;
            //确定输出数组
            List<Integer> resultList = new ArrayList<Integer>();
            while(nums1Head < nums1.length && nums2Head < nums2.length ){
              if(nums1[nums1Head] == nums2[nums2Head]){
                resultList.add(nums1[nums1Head]);
                nums1Head++;
                nums2Head++;
                continue;
              }else if(nums1[nums1Head] < nums2[nums2Head]){
                nums1Head++;
                continue;
              }else if(nums1[nums1Head] > nums2[nums2Head]){
                nums2Head++;
                continue;
              }
            }
            int result[] = new int[resultList.size()];
            for (int i=0; i < result.length; i++)
            {
                result[i] = resultList.get(i).intValue();
            }
            return result;
        }

    解法II Counter计数
    该解法不需要将nums2一次性加载到内存中
    def intersect(self, nums1, nums2): """ :type nums1: List[int] :type nums2: List[int] :rtype: List[int] """ if len(nums1) > len(nums2): nums1, nums2 = nums2, nums1 c = collections.Counter(nums1) ans = [] for x in nums2: if c[x] > 0: ans += x, c[x] -= 1 return ans

    Map<Integer, Long> map = Arrays.stream(nums2).boxed().collect
    (Collectors.groupingBy(e->e, Collectors.counting())); return Arrays.stream(nums1).filter(e ->{ if(!map.containsKey(e)) return false; map.put(e, map.get(e) - 1); if(map.get(e) == 0) map.remove(e); return true; }).toArray();

    [JAVA] What's the best way you think to convert List<Integer> to a normal int array?
    int[] array = list.stream().mapToInt(i->i).toArray();
    
    list.stream().mapToInt(Integer :: intValue).toArray()
    
    X. Follow up
    https://leetcode.com/discuss/103969/solution-to-3rd-follow-up-question
    What if elements of nums2 are stored on disk, and the memory is
    limited such that you cannot load all elements into the memory at
    once?
    • If only nums2 cannot fit in memory, put all elements of nums1 into a HashMap, read chunks of array that fit into the memory, and record the intersections.
    • If both nums1 and nums2 are so huge that neither fit into the memory, sort them individually (external sort), then read 2 elements from each array at a time in memory, record intersections.
    I think the second part of the solution is impractical, if you read 2 elements at a time, this procedure will take forever. In principle, we want minimize the number of disk access during the run-time.
    An improvement can be sort them using external sort, read (let's say) 2G of each into memory and then using the 2 pointer technique, then read 2G more from the array that has been exhausted. Repeat this until no more data to read from disk.
    But I am not sure this solution is good enough for an interview setting. Maybe the interviewer is expecting some solution using Map-Reduce paradigm.
    http://faculty.simpson.edu/lydia.sinapova/www/cmsc250/LN250_Weiss/L17-ExternalSortEX2.htm
    http://massivealgorithms.blogspot.com/2014/07/exceptional-code-external-sorting-for.html
    http://buttercola.blogspot.com/2016/06/leetcode-intersection-of-two-arrays-ii.html

    • What if the given array is already sorted? How would you optimize your algorithm?
      • Solution 1, i.e., sorting,  would be better since it does not need extra memory. 
    • What if nums1's size is small compared to num2's size? Which algorithm is better?
      • If two arrays are sorted, we could use binary search, i.e., for each element in the shorter array, search in the longer one. So the overall time complexity is O(nlogm), where n is the length of the shorter array, and m is the length of the longer array. Note that this is better than Solution 1 since the time complexity is O(n + m) in the worst case. 
    • What if elements of nums2 are stored on disk, and the memory is limited such that you cannot load all elements into the memory at once?
      • If the two arrays have relatively the same length, we can use external sort to sort out the two arrays in the disk. Then load chunks of each array into the memory and compare, by using the method 1. 
      • If one array is too short while the other is long, in this case, if memory is limited and nums2 is stored in disk, partition it and send portions of nums2 piece by piece. keep a pointer for nums1 indicating the current position, and it should be working fine~
      • Another method is, store the larger array into disk, and for each element in the shorter array, use "Exponential Search" and search in the longer array. 
    https://helloyuantechblog.wordpress.com/2016/06/20/leetcode-350-intersection-of-two-arrays-ii-easy/
        vector<int> intersect(vector<int>& nums1, vector<int>& nums2) {
            //sort(nums1.begin(), nums1.end()); not needed
            sort(nums2.begin(), nums2.end());
            vector<int> result;
            int len1 = nums1.size(), len2 = nums2.size();
            for(int i = 0; i < nums1.size(); i++) { if (i > 0 && nums1[i] == nums1[i-1]) {
                    continue;
                }
                int j = binarySearch(nums2, nums1[i]);
                if (j != -1) {
                    result.push_back(nums1[i]);
                    while(i + 1 < len1 && nums1[i+1] == nums1[i] && j + 1 < len2 && nums2[j+1] == nums2[j]) {
                        result.push_back(nums1[i]);
                        i++; j++;
                    }
                }
            }
            return result;
        }
        int binarySearch(vector<int>& nums, int target) {
            if (nums.empty()) {
                return -1;
            }
            int start = 0, end = nums.size()-1, mid;
            while(start + 1 < end) {
                mid = start + (end - start) / 2;
                if (nums[mid] < target) {
                    start = mid + 1;
                } else {
                    end = mid;
                }
            }
            if (nums[start] == target) {
                return start;
            }
            if (nums[end] == target) {
                return end;
            }
            return -1;
        }
    https://discuss.leetcode.com/topic/49329/all-the-follow-up-solution
    1.What if the given array is already sorted? How would you optimize your algorithm?
    class Solution {
    public:
        vector<int> intersect(vector<int>& nums1, vector<int>& nums2) {
            vector<int> res;
            if(nums1.empty() || nums2.empty())
                return res;
            for(int i=0,j=0; i<nums1.size() && j<nums2.size(); ) {
                if(nums1[i] == nums2[j]) {
                    res.push_back(nums2[j]);
                    ++j;
                    ++i;
                }else if(nums1[i] < nums2[j]) {
                    ++i;
                }else if(nums1[i] > nums2[j]) {
                    ++j;
                }
            }
            return res;
        }
    };
    
    2.What if nums1's size is small compared to nums2's size? Which algorithm is better?
    class Solution {
    public:
        vector<int> intersect(vector<int>& nums1, vector<int>& nums2) {
            unordered_map<int, int> mymap;
            vector<int> res;
            for(auto it : nums1) {
                mymap[it]++;
            }
            for(auto it : nums2) {
                if(--mymap[it] >= 0) {
                    res.push_back(it);
                }
            }
            return res;
    
        }
    };
    http://wxx5433.github.io/common-elements.html
    Since the question says is two sorted sets, it means there are no duplicate elements. Otherwise, we need to deal with it very carefully. We may discuss with the interviewer what we should return in the following case:
        A = {5, 5, 6}
        B = {5, 5, 7}
    
    Should we return {5, 5} or just {5}?

    Labels

    LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

    Popular Posts